Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1902632 - Review Request: python-imbalanced-learn - A Python Package to Tackle the Imbalanced Datasets in Machine Learning
Summary: Review Request: python-imbalanced-learn - A Python Package to Tackle the Imba...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Aniket Pradhan
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2020-11-30 09:04 UTC by Iztok Fister Jr.
Modified: 2020-12-26 13:50 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-12-26 13:50:46 UTC
Type: ---
Embargoed:
aniketpradhan1999: fedora-review+


Attachments (Terms of Use)

Description Iztok Fister Jr. 2020-11-30 09:04:03 UTC
Spec URL: https://raw.githubusercontent.com/firefly-cpp/imbalanced-learn-rpm/main/python-imbalanced-learn.spec

SRPM URL: https://github.com/firefly-cpp/imbalanced-learn-rpm/raw/main/python-imbalanced-learn-0.7.0-1.fc33.src.rpm

Description: imbalanced-learn is a python package offering a number of re-sampling techniques commonly used in datasets showing strong between-class imbalance. It is compatible with scikit-learn and is part of scikit-learn-contrib projects.

Fedora Account System Username: iztokf

Comment 1 Aniket Pradhan 2020-12-04 10:15:34 UTC
Hey there Iztok!

Everything seems great, although you're not running the tests for the package. From what I can see, if there is a Tensorflow/Keras dependency on the test, it is automatically skipped if they are not installed on the system. So, I think you can run and test the other remaining functionality of the package. And if there are tests that do not skip automatically, you can always disable those few tests.


Also, if possible, try adding in a doc package, but if it too is constrained by the TF or Keras, no need to worry then.

Other than that, you can replace this line:

> %{?python_provide:%python_provide python3-%{pretty_name}}

so that it uses the `%{py_provides}` macro. For more info on that, refer here [0]


[0]: https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_the_py_provides_macro 




Full review here:


This is a review *template*. Besides handling the [ ]-marked tests you are
also supposed to fix the template before pasting into bugzilla:
- Add issues you find to the list of issues on top. If there isn't such
  a list, create one.
- Add your own remarks to the template checks.
- Add new lines marked [!] or [?] when you discover new things not
  listed by fedora-review.
- Change or remove any text in the template which is plain wrong. In this
  case you could also file a bug against fedora-review
- Remove the "[ ] Manual check required", you will not have any such lines
  in what you paste.
- Remove attachments which you deem not really useful (the rpmlint
  ones are mandatory, though)
- Remove this text



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License", "BSD 3-clause "New" or
     "Revised" License BSD 2-clause "Simplified" License". 194 files have
     unknown license. Detailed output of licensecheck in
     /home/major/Documents/NeuroFedora/review/1902632-python-imbalanced-
     learn/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[-]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-imbalanced-learn-0.7.0-1.fc34.noarch.rpm
          python-imbalanced-learn-0.7.0-1.fc34.src.rpm
python3-imbalanced-learn.noarch: W: spelling-error %description -l en_US scikit -> sci kit, sci-kit, kitsch
python3-imbalanced-learn.noarch: W: spelling-error %description -l en_US contrib -> cont rib, cont-rib, contribute
python-imbalanced-learn.src: W: spelling-error %description -l en_US datasets -> data sets, data-sets, databases
python-imbalanced-learn.src: W: spelling-error %description -l en_US scikit -> sci kit, sci-kit, kitsch
python-imbalanced-learn.src: W: spelling-error %description -l en_US contrib -> cont rib, cont-rib, contribute
2 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
python3-imbalanced-learn.noarch: W: spelling-error %description -l en_US scikit -> sci kit, sci-kit, kitsch
python3-imbalanced-learn.noarch: W: spelling-error %description -l en_US contrib -> cont rib, cont-rib, contribute
1 packages and 0 specfiles checked; 0 errors, 2 warnings.



Source checksums
----------------
https://github.com/scikit-learn-contrib/imbalanced-learn/archive/0.7.0/imbalanced-learn-0.7.0.tar.gz :
  CHECKSUM(SHA256) this package     : 3ecfac7d4f4d3e303b5e49bd1077c36bdef90b696909997f3f30fb077e702f7b
  CHECKSUM(SHA256) upstream package : 3ecfac7d4f4d3e303b5e49bd1077c36bdef90b696909997f3f30fb077e702f7b


Requires
--------
python3-imbalanced-learn (rpmlib, GLIBC filtered):
    python(abi)
    python3.9dist(joblib)
    python3.9dist(numpy)
    python3.9dist(scikit-learn)
    python3.9dist(scipy)



Provides
--------
python3-imbalanced-learn:
    python-imbalanced-learn
    python3-imbalanced-learn
    python3.9-imbalanced-learn
    python3.9dist(imbalanced-learn)
    python3dist(imbalanced-learn)



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 1902632
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Shell-api, Generic
Disabled plugins: Perl, Java, Haskell, Ocaml, R, PHP, fonts, SugarActivity, C/C++
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 2 Iztok Fister Jr. 2020-12-04 12:51:12 UTC
Hi Aniket!

Thank you very much for review.

A new version has already been uploaded on GH. Tests are now enabled. One test is skipped.

However, I downgraded a version (from 0.7.0 to 0.6.2). In fact, additional issues appeared when tests were enabled.

Comment 4 Aniket Pradhan 2020-12-07 11:59:06 UTC
That's great if you can package the latest version.

Just a bit small nits,

1. Please leave a small comment in the spec, about why you're disabling the tests.
2. If possible, please report the issues in the tests to upstream, so that they can patch it up.
3. I believe there are other tests in the project directory, so I guess there's no need to manually specify a particular directory and let pytest discover the tests automatically.

Other than that, the spec is amazing, and I am approving the review. After doing the above changes, you can manually proceed with the repo creation!

Good Luck :D

Comment 5 Iztok Fister Jr. 2020-12-07 12:46:09 UTC
Thanks very much Aniket.

Comment 6 Gwyn Ciesla 2020-12-07 14:18:58 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-imbalanced-learn


Note You need to log in before you can comment on or make changes to this bug.